// GITVERSION: HPCMC.9-24-gdf6eded7
#ifndef EVAL_HPP
#define EVAL_HPP
#include "aedtools/evalbase.hpp"
#include <forward_list>
#include <sstream>
#include <algorithm>
#include <mpi.h>
using namespace std;

namespace aed {

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  //   FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  // No functions this time
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  // END FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> TRANSPOSE
#define TRACE(s) cout << "TRACE: " << s << endl
#undef EJERC
#undef EVAL
#define EJERC 1
#define EVAL eval1_t
  typedef vector< vector<int> > vvint_t;
  typedef void (*transpose_t)(vvint_t &sbuff,vvint_t &rbuff,MPI_Comm comm);
  class EVAL : public eval_base_t {
  public:
    transpose_t F;
    EVAL() { dumptests=1; F=NULL; ejerc=EJERC; testfile="./trp.json"; }
    void run_case(json &data,json &outuser) {
      vvint_t sbuff,rbuff;
      for (auto q:data) {
        vector<int> v = q;
        sbuff.push_back(v);
      }
      rbuff = sbuff;
      F(sbuff,rbuff,comm);
      outuser.clear();
      for (auto q:rbuff) {
        json z = q;
        outuser.push_back(z);
      }
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      datain.clear();
      int
        nproc = 2+rnd.rand()%3,
        N=2+rnd.rand()%3;
      for(int p=0;p<nproc;p++) {
        json buffp;
        for(int q=0;q<nproc;q++) {
          json vj;
          for (int j=0; j<N; j++) {
            int x = rnd.rand()%10;
            vj.push_back(x);
          }
          buffp.push_back(vj);
        }
        datain.push_back(buffp);
      }
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> TRANSPOSE
#undef EJERC
#undef EVAL
#define EJERC 2
#define EVAL eval2_t
  typedef void (*parfind_t)(vector<int> &v,int x,
                            int &procfirst,int &kfirst,int &count,MPI_Comm comm);
  class EVAL : public eval_base_t {
  public:
    parfind_t F;
    EVAL() { dumptests=0; F=NULL; ejerc=EJERC; testfile="./pf.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v = data["v"];
      int x = data["x"];
      int procfirst,kfirst,count;
      F(v,x,procfirst,kfirst,count,comm);
      outuser["procfirst"] = procfirst;
      outuser["kfirst"] = kfirst;
      outuser["count"] = count;
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      datain.clear();
      int
        nproc = 2+rnd.rand()%3,
        N=2+rnd.rand()%3;
      for(int p=0;p<nproc;p++) {
        json buffp;
        for(int q=0;q<nproc;q++) {
          json vj;
          for (int j=0; j<N; j++) {
            int x = rnd.rand()%10;
            vj.push_back(x);
          }
          buffp.push_back(vj);
        }
        datain.push_back(buffp);
      }
    }
  };
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  using Eval = eval_t<eval1_t,transpose_t,
                      eval2_t,parfind_t>;

}
#undef CSTR

#endif
